# Rule Verification

Used to check for various processing rules such as surcharge eligibility.

 Integration Methods:
- Host Direct

See the Integration Methods and URLs Section sections of the Development Quick Start guide for details regarding each processing option.

See the JSON Body Schemas for more details on the various JSON body formats.

Endpoint: POST /rule/verify
Version: 1.7.56
Security: AccessToken

## Header parameters:

  - `InterfaceVersion` (string, required)
    Refers to the version of the program or application that is sending requests to Shift4. The following special characters are not allowed&colon;  $ % &colon; ^ - ~  , ? “ ” ‘ ’ { } [ ] \ + =
    Example: "2.1"

  - `InterfaceName` (string, required)
    Refers to the name of the program or application that is sending requests to Shift4. This should be the name of the program that you purchased or created. The following special characters are not allowed&colon;  $ % &colon; ^ - ~ `  , ? “ ” ‘ ’ { } [ ] \ + =
    Example: "ForwardPOS"

  - `CompanyName` (string, required)
    Refers to the vendor or partner that designed and certified the interface. The information you use in this field should match what Shift4 has on file or what was agreed upon in your Integration Plan. The following special characters are not allowed&colon;  $ % &colon; ^ - ~ `  , ? “ ” ‘ ’ { } [ ] \ + =
    Example: "PAWS"

  - `AccessToken` (string, required)
    A security credential used to authenticate API requests and all i4Go® authorizeClient/preauthorizeClient requests. An Access Token is the alias for the merchant account and interface being used. The Access Token is required in all requests except an Access Token Exchange request, which generates an Access Token using an authToken and clientGuid.
    Example: "EA79FB05-3AA7-4500-AF9A-73F986FF2C1D"

## Request fields (application/json):

  - `body` (object, required) — one of:
    - GTV Token:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested.

Note: For merchants that are configured to allow multiple currencies, the amount fields can specify up to three decimal places. However, the number of decimal places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
      - `ruleCheck` (array, required)
        Specifies which rule checks are being requested:
  
| Value     | Description                                                                                                                                                       |
|-----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| SURCHARGE | Checks to see if a card is eligible for surcharging. If eligible the surcharge object will be returned containing the surcharge percentage that can be applied. |
        Enum: "SURCHARGE"
      - `transaction` (object, required)
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `card` (object, required)
      - `card.token` (object, required)
      - `card.token.value` (string, required)
        This field is used to specify a card token. Whenever CHD is sent in a request, a card token will be returned in this field. Your interface should be designed to store this card token for future use. The latest card token received should be used in any subsequent request that references the same card data.
      - `card.expirationDate` (integer)
        Conditional: Send only when card data is manually entered or when using a token. This field should not be specified when using an encrypted device.

Card expiration date in MMYY format. This value should only be populated in the initial sale/authorization request.
      - `clerk` (object)
      - `clerk.numericId` (integer)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
    - P2PE - ID TECH - EMV/MSR/Manual:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested.

Note: For merchants that are configured to allow multiple currencies, the amount fields can specify up to three decimal places. However, the number of decimal places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
      - `ruleCheck` (array, required)
        Specifies which rule checks are being requested:
  
| Value     | Description                                                                                                                                                       |
|-----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| SURCHARGE | Checks to see if a card is eligible for surcharging. If eligible the surcharge object will be returned containing the surcharge percentage that can be applied. |
        Enum: same as `ruleCheck` in "GTV Token" (1 values)
      - `transaction` (object, required)
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `p2pe` (object, required)
      - `p2pe.data` (string, required)
        The full output of a P2PE keypad/magnetic swipe reader (MSR).
      - `p2pe.format` (string, required)
        Classifies the type of payment device being used for P2PE.

Value|Description
-----|-----------
01   | IDTech Enhanced Encryption format (Keyboard Mode)
02   | IDTech Enhanced Encryption format (USB HID Mode)
        Enum: "01", "02"
      - `clerk` (object)
      - `clerk.numericId` (integer)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
    - P2PE - TDES DUKPT - EMV:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested.

Note: For merchants that are configured to allow multiple currencies, the amount fields can specify up to three decimal places. However, the number of decimal places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
      - `ruleCheck` (array, required)
        Specifies which rule checks are being requested:
  
| Value     | Description                                                                                                                                                       |
|-----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| SURCHARGE | Checks to see if a card is eligible for surcharging. If eligible the surcharge object will be returned containing the surcharge percentage that can be applied. |
        Enum: same as `ruleCheck` in "GTV Token" (1 values)
      - `transaction` (object, required)
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `p2pe` (object, required)
        See [P2PE Format 05 TDES DUKPT](/guides/core-concepts/p2pe-format#tdes-dukpt---format-05) for more information.
      - `p2pe.format` (string, required)
        Classifies the type of payment device being used for P2PE.

Value|Description
-----|-----------
05   | [Shift4 TDES DUKPT format](/guides/core-concepts/p2pe-format#tdes-dukpt---format-05)
        Enum: "05"
      - `p2pe.ksn` (string, required)
        The key serial number which was used to encrypt the P2PE data.
      - `emv` (object, required)
        Encrypted EMV tags
      - `emv.tlvData` (string, required)
        This field contains the P2PE encrypted tags (5A and 57) in standard TLV format.  The P2PE encrypted tags (5A and 57) will have the entire TLV string encrypted and the encrypted data will be in a TLV format using the same tag. For example, tag 5A would look like the following:
- Encrypted: 5A181CF757386DE00BC2DE05F965DB1E96D867C2009CA8C3179
- Decrypted: 5A084761739001010010
        Example: "5A181CF757386DE00BC2DE05F965DB1E96D867C2009CA8C31799573083FBDC0892887F7C99E0B7E54520CCC94308B4E4C7D4C18CDCE4EAA83C4D18A6AFDCD53EAC46BD5630834EFB238F32B3"
      - `clerk` (object)
      - `clerk.numericId` (integer)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
    - P2PE - TDES DUKPT - MSR/Manual:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested.

Note: For merchants that are configured to allow multiple currencies, the amount fields can specify up to three decimal places. However, the number of decimal places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
      - `ruleCheck` (array, required)
        Specifies which rule checks are being requested:
  
| Value     | Description                                                                                                                                                       |
|-----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| SURCHARGE | Checks to see if a card is eligible for surcharging. If eligible the surcharge object will be returned containing the surcharge percentage that can be applied. |
        Enum: same as `ruleCheck` in "GTV Token" (1 values)
      - `transaction` (object, required)
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `p2pe` (object, required)
        See [P2PE Format 05 TDES DUKPT](/guides/core-concepts/p2pe-format#tdes-dukpt---format-05) for more information.
      - `p2pe.data` (string, required)
        The full output of a P2PE keypad/magnetic swipe reader (MSR).
      - `p2pe.format` (string, required)
        Classifies the type of payment device being used for P2PE.

Value|Description
-----|-----------
05   | [Shift4 TDES DUKPT format](/guides/core-concepts/p2pe-format#tdes-dukpt---format-05)
        Enum: same as `p2pe.format` in "P2PE - TDES DUKPT - EMV" (1 values)
      - `p2pe.ksn` (string, required)
        The key serial number which was used to encrypt the P2PE data.
      - `clerk` (object)
      - `clerk.numericId` (integer)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
    - P2PE - On-Guard SDE - EMV:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested.

Note: For merchants that are configured to allow multiple currencies, the amount fields can specify up to three decimal places. However, the number of decimal places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
      - `ruleCheck` (array, required)
        Specifies which rule checks are being requested:
  
| Value     | Description                                                                                                                                                       |
|-----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| SURCHARGE | Checks to see if a card is eligible for surcharging. If eligible the surcharge object will be returned containing the surcharge percentage that can be applied. |
        Enum: same as `ruleCheck` in "GTV Token" (1 values)
      - `transaction` (object, required)
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `p2pe` (object, required)
        See [P2PE Format 03 Ingenico On-Guard SDE](/guides/core-concepts/p2pe-format#ingenico-on-guard-sde---format-03) for more information.
      - `p2pe.data` (string, required)
        EMV TLV Data for tags 5A and 57 encrypted with AES 256 DUKPT. Contains the following information, separated by colons:
  
Value           | Description
----------------|------------
ksn             | The key serial number (24 byte hex)
track indicator | E indicating EMV TLV Data
length          | The length of the encrypted data
encrypted data  | Encrypted TLV containing tags 57 and 5A

Example: FFFF495A0000000200000002:E:0032:E0AB94F7704E77AB37F81A7E236A1ABC1465C6DFCE43A506240D6E7D6DDA7EA9
      - `p2pe.format` (string, required)
        Classifies the type of payment device being used for P2PE.

Value|Description
-----|-----------
03   | Ingenico Onguard SDE Format
        Enum: "03"
      - `clerk` (object)
      - `clerk.numericId` (integer)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
    - P2PE - On-Guard SDE - MSR/Manual:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested.

Note: For merchants that are configured to allow multiple currencies, the amount fields can specify up to three decimal places. However, the number of decimal places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
      - `ruleCheck` (array, required)
        Specifies which rule checks are being requested:
  
| Value     | Description                                                                                                                                                       |
|-----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| SURCHARGE | Checks to see if a card is eligible for surcharging. If eligible the surcharge object will be returned containing the surcharge percentage that can be applied. |
        Enum: same as `ruleCheck` in "GTV Token" (1 values)
      - `transaction` (object, required)
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `p2pe` (object, required)
        See [P2PE Format 03 Ingenico On-Guard SDE](/guides/core-concepts/p2pe-format#ingenico-on-guard-sde---format-03) for more information.
      - `p2pe.data` (string, required)
        Track information encrypted with AES 256 DUKPT. Contains the following information, separated by colons:
  
|Value           | Description
|----------------|------------
|ksn             | The key serial number (24 byte hex)
|track indicator | 1 = track 1 only2 = track 2 only3 = manual entry4 = dual track
|length          | The length of the encrypted data
|encrypted data  | Encrypted track/manual entry data

Dual Track Example: FFFF495A0000000200000005:4:0128:F48C880DE0DAF549E642C5CC25E65ADF9947E7EB0636DB80C4A490B4C0930AEF64B7201505343CED533A2AE9AFABFE6453875F705519A8109362197CA3BD8DA0FE90DB3F954B9CDA0DB58BDA3330862ADD28CB31EFDA7C641575E33D395D8BFF72EBF0B1FF9630DB0EAB080FE8C9B2FAC28127CDC48CA9F7D532D5BDE4CCE270

Manual entry Example: FFFF495A0000000200000006:3:0032:E394820DB97AF927B9B5E05F356750BBF5DFCCB3BC18B87E8FC3C9BC596229E7
      - `p2pe.format` (string, required)
        Classifies the type of payment device being used for P2PE.

Value|Description
-----|-----------
03   | Ingenico Onguard SDE Format
        Enum: same as `p2pe.format` in "P2PE - On-Guard SDE - EMV" (1 values)
      - `clerk` (object)
      - `clerk.numericId` (integer)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
    - Card Number Unencrypted:
      - `dateTime` (string, required)
        The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
      - `amount` (object, required)
        Object containing information regarding the amount being requested. The total field within the object is required and specifies the amount being requested.

Note: For merchants that are configured to allow multiple currencies, the amount fields can specify up to three decimal places. However, the number of decimal places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
      - `amount.total` (number, required)
        The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
      - `ruleCheck` (array, required)
        Specifies which rule checks are being requested:
  
| Value     | Description                                                                                                                                                       |
|-----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| SURCHARGE | Checks to see if a card is eligible for surcharging. If eligible the surcharge object will be returned containing the surcharge percentage that can be applied. |
        Enum: same as `ruleCheck` in "GTV Token" (1 values)
      - `transaction` (object, required)
      - `transaction.invoice` (string, required)
        10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.
      - `transaction.vendorReference` (string)
        Optional field for information that can be searched in the merchant portal.
      - `card` (object, required)
      - `card.number` (string, required)
        The payment card number entered in an initial authorization/sale request. This field will always be masked when returned in a response.
      - `card.expirationDate` (integer, required)
        Conditional: Send only when card data is manually entered or when using a token. This field should not be specified when using an encrypted device.

Card expiration date in MMYY format. This value should only be populated in the initial sale/authorization request.
      - `clerk` (object)
      - `clerk.numericId` (integer)
        A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.

## Response 200 fields (application/json):

  - `result` (array)

  - `result.dateTime` (string)
    The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).

Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00

  - `result.amount` (object)

  - `result.amount.total` (number)
    The total amount being charged for a particular transaction.

If the ruleCheck array contained SURCHARGE in the request and the card is surcharge eligible the amount.total value will be incremented by the amount.surcharge value. For example, if the rule verification request had amount.total = 100 and the surcharge.percentage was 1.5%, the rule verification response would include amount.total = 101.50 and amount.surcharge = 1.50

  - `result.amount.surcharge` (number)
    Conditional: Returned if the ruleCheck array contained SURCHARGE in the request and the card is surcharge eligible.

The surcharge fee amount that can be applied to the transaction. The fee amount is also added into amount.total. For example, if the rule verification request had amount.total = 100 and the surcharge.percentage was 1.5%, the rule verification response would include amount.total = 101.50 and amount.surcharge = 1.50

  - `result.card` (object)

  - `result.card.number` (string)
    The card number field will always be masked when returned in a response.

  - `result.card.token` (object)

  - `result.card.token.value` (string)
    This field is used to specify a card token. Whenever CHD is sent in a request, a card token will be returned in this field. Your interface should be designed to store this card token for future use. The latest card token received should be used in any subsequent request that references the same card data.

  - `result.card.type` (string)
    An abbreviation used to specify the type of card that was used when processing a transaction.

Value| Description
-----|------------
AX   | American Express
AP   | Alipay
BC   | Backed Card       
CI   | Citgo        
DB   | Debit card
GC   | Gift Card
JC   | JCB
MC   | Mastercard
NS   | Discover/JCB/Novus
PL   | Private Label
SC   | Sears Canada
VS   | Visa
WP   | WeChat Pay
YC   | IT’S YOUR CARD
    Enum: "AX", "AP", "BC", "CI", "DB", "GC", "JC", "MC", "NS", "PL", "SC", "VS", "WP", "YC"

  - `result.surcharge` (object)
    Returned if the ruleCheck array contained SURCHARGE in the request.

  - `result.surcharge.result` (string)
    Result of the surcharge eligibility check:

| Value | Description                                 |
|-------|---------------------------------------------|
| P     | Pass - Card is eligible for surcharging     |
| F     | Fail - Card is not eligible for surcharging |
    Enum: "P", "F"

  - `result.surcharge.transactionId` (string)
    Transaction ID for the rule check

  - `result.surcharge.percentage` (number)
    The surcharge percentage that can be applied to a transaction.

  - `result.transaction` (object)

  - `result.transaction.invoice` (string)
    10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.

Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.

For processing outside of the US and Canada alpha characters are allowed.

  - `result.transaction.vendorReference` (string)
    Optional field for information that can be searched in the merchant portal.

  - `result.transaction.authSource` (string)
    In a response, a code returned by the processor to indicate which host issued the response.

Value  | Description       
-------|----------------------------
E      | Engine (Online)
O      | Offline
A      | APM (Online)
F      | Payment Platform (Online)
    Enum: "E", "O", "A", "F"

  - `result.merchant` (object)

  - `result.merchant.mid` (number)
    The merchant ID associated with the merchant account.

  - `result.merchant.name` (string)
    The merchant’s business name as configured with Shift4.

  - `result.clerk` (object)

  - `result.clerk.numericId` (integer)
    A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.

  - `result.currencyCode` (string)
    Transaction currency code. See the [Currency Codes](/guides/appendices/currency-codes) section for details.

Note: This is currently supported when processing for a merchant outside of the US and Canada. If processing for a US or Canadian merchant then this field will be ignored and the transaction will process in the merchant's configured currency.

  - `result.universalToken` (object)

  - `result.universalToken.value` (string)
    An identifier for a card or payment account across all Shift4 merchants.

  - `result.server` (object)

  - `result.server.name` (string)
    The name of the server that processed the request.

## Response 400 fields (application/json):

  - `result` (array)
    Example: [{"error":{"primaryCode":9842,"secondaryCode":0,"shortText":"NOT IN CARDRANGE","longText":"Card type not recognized"},"lighthouse":{"data":"eyJwYXltZW50SWQiOiI4NWM0MWNhNy01NzVjLTQzNGUtODIyZi0xYzZlOTE0ZDAzODYiLCJyZW1haW5pbmdBbW91bnQiOjB9"},"server":{"name":"U2API01CE"}}]

  - `result.error` (object)

  - `result.error.code` (integer)
    Code indicating the type of error that occurred. Refer to the [Error Codes](/guides/appendices/error-codes) section of this document for more details.

Note: This is currently only supported for European merchant processing.

  - `result.error.severity` (string)
    Severity level of the error.

| Severity | Description                                                       |
| -------- | ----------------------------------------------------------------  |
| Info     | Action not required - Data input/formatting is incorrect          |
| Error    | Action may be required - Communication, timeout or network issue  |
| Alert    | Action required - System issue                                    |
    Enum: "Info", "Error", "Alert"

  - `result.error.shortText` (string)
    Abbreviated error message that is always returned if an error condition exists

  - `result.error.longText` (string)
    Extended error message that is returned if an error condition exists.

  - `result.error.primaryCode` (integer)
    Code indicating the type of error that occurred. Refer to the [Error Codes](/guides/appendices/error-codes) section of this document for more details.

  - `result.error.secondaryCode` (integer)
    This code supplements the code specified in the error.primaryCode field to provide additional information about the error that occurred.

  - `result.lighthouse` (object)

  - `result.lighthouse.data` (string)
    Base64 encoded JSON formatted data that will be returned from Lighthouse to be passed back to SkyTab. This data will contain variable information.

  - `result.server` (object)

## Response 504 fields (application/json):

  - `result` (array)

  - `result.error` (object)

  - `result.lighthouse` (object)

  - `result.lighthouse.data` (string)
    Base64 encoded JSON formatted data that will be returned from Lighthouse to be passed back to SkyTab. This data will contain variable information.

  - `result.server` (object)


